import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;
import java.lang.reflect.Method;
import javax.swing.*;
import javax.imageio.*;

public class BoutonFichier extends JButton implements ActionListener {
   private BufferedImage photoOriginale;
   private ZoneImage zoneImage;
   
   public BoutonFichier(String libell, Icon icne, ZoneImage zone) {
      super(libell, icne);
      zoneImage = zone;
      photoOriginale = zoneImage.getImageOriginale();
      this.addActionListener(this);
   }
   
   public void actionPerformed(ActionEvent e) {
      JFileChooser fichiers = new JFileChooser();
      if (fichiers.showOpenDialog(null) == JFileChooser.APPROVE_OPTION)               
         try {
            photoOriginale = ImageIO.read(fichiers.getSelectedFile());
            zoneImage.changeImageOriginale(photoOriginale);
         } 
         catch (IOException ex) {
            ex.printStackTrace();
         }                  
   }
}

class Bouton extends JButton implements ActionListener {
   private ZoneImage zone;
   private Method mthode;
   
   public Bouton(String libell, Icon icne, ZoneImage zone, String mthode) {
      super(libell, icne);
      this.zone = zone;
      try {
         this.mthode = zone.getClass().getMethod(mthode);
      } 
      catch (Exception ex) {
         ex.printStackTrace();
      } 
      addActionListener(this);    
      this.setPreferredSize(new Dimension(this.getWidth(), 36));
   }
   public void actionPerformed(ActionEvent e) {
      try {
         mthode.invoke(zone);
      } 
      catch (Exception ex) {
         ex.printStackTrace();
      }       
   }   
}