import java.awt.*;
import java.awt.image.*;
import javax.swing.*;

class Courbe extends JComponent {
   private BufferedImage image;
   private WritableRaster trame;
   private int[] rouge = {255, 0, 0};
   private int[] courbeInitiale = new int[256];
   private int[] courbe = new int[256];
   private int fortesDensits;
   private int hautesLumires;
   private int intensit;
   private int contraste;
   private int dcalageNoir;
   private int dcalageBlanc;
   
   public Courbe() {
     calcul();
   }
   protected void paintComponent(Graphics surface) {
      surface.drawImage(image, 0, 0, null);   
   }   

   public void attnuationFortesDensits(int valeur) {
      fortesDensits = valeur;
      calcul();
   }   
   public void diminutionHautesLumires(int valeur) {
      hautesLumires = valeur;
      calcul();      
   }
   public void intensitLumineuse(int valeur) {
      intensit = valeur;
      calcul();            
   }
   public void rglerContraste(int valeur) {
      contraste = valeur;
      calcul();                
   }
   public void rglerDcalageNoir(int valeur) {
      dcalageNoir = valeur;
      calcul();                      
   }
   public void rglerDcalageBlanc(int valeur) {
      dcalageBlanc = valeur;
      calcul();                      
   }
   
   public void calcul() {
      for (int i=0; i<256; i++) 
         courbeInitiale[i] = (int) ((255-fortesDensits-hautesLumires)*(i-dcalageNoir)/(255-dcalageNoir-dcalageBlanc)+intensit*Math.sin((i-dcalageNoir)*Math.PI/(255-dcalageNoir-dcalageBlanc))-contraste*Math.sin((i-dcalageNoir)*2*Math.PI/(255-dcalageNoir-dcalageBlanc))+fortesDensits);
//         solarisation[i] = (int)(255*Math.sin(i*Math.PI/255));
//         inverser[i] = 255-i;
      rajuster();
      tracer();
   }   
   private void rajuster() {
      for (int i=0; i<256; i++) {
         if (courbeInitiale[i]<0)               courbe[i] = 0;
         else if (courbeInitiale[i]>255)   courbe[i] = 255;
         else                                             courbe[i] = courbeInitiale[i];
      }
   }
   private void tracer() {
      image = new BufferedImage(256, 256, BufferedImage.TYPE_INT_RGB);       
      trame = image.getRaster();
      for (int x=0; x<256; x++) {
         trame.setPixel(x, 255-courbe[x], rouge);
      }
      repaint();
   }
}