import java.awt.event.*;
import java.awt.image.*;
import javax.swing.*;
import java.awt.*;

public class Fentre extends JFrame {
   private JToolBar barreBoutons = new JToolBar();
   private ZoneImage image = new ZoneImage();
   private BoutonFichier boutonNouvellePhoto = new BoutonFichier("Rcuprer la photo", new ImageIcon("nouveau.gif"), image);
   private Bouton boutonNgatif = new Bouton("Ngatif", new ImageIcon("ngatif.gif"), image, "ngatif");
   private Bouton boutonNoirBlanc = new Bouton("Noir et Blanc", new ImageIcon("noirblanc.gif"), image, "noirEtBlanc");
   private Bouton boutonRotationGauche = new Bouton("Rotation gauche", new ImageIcon("gauche.gif"), image, "rotationGauche");
   private Bouton boutonRotationDroite = new Bouton("Rotation droite", new ImageIcon("droite.gif"), image, "rotationDroite");
   private Bouton boutonReinitialiser = new Bouton("Image originale", new ImageIcon("annuler.gif"), image, "reinitialiser");
   private Bouton boutonRetailler = new Bouton("Retailler", new ImageIcon("retailler.gif"), image, "changerTaille");
   private Bouton boutonSauvegarder = new Bouton("Sauvegarder", new ImageIcon("sauvegarder.gif"), image, "sauvegarder");
   private JPanel palettes = new JPanel();
   
   private PaletteHistogramme histogramme = new PaletteHistogramme(image);
   /**
    * Dans cette palette se trouve les rglages des niveaux : 
    *    Noir profond,
    *    Blanc le plus intense,
    *    Intensit lumineuse : Assombrir ou clairer l'image.
    */
   private PaletteNiveaux niveaux = new PaletteNiveaux(image);
   /**
    * Dans cette palette se trouve les rglages des extrmes : 
    *    Attnuation des fortes densits (parties les plus sombres),
    *    Diminution des hautes lumires.
    */
   private PaletteAttnuation attnuation = new PaletteAttnuation(image);
   /**
    * Dans cette palette se trouve les rglages des accentuations : 
    *    Contraste (les parties sombres deviennent encore plus sombres, les parties claires deviennent encore plus claires),
    *    Saturations (Augmenter les couleurs si ces dernires sont fades).
    */
   private PaletteAccentuation accentuation = new PaletteAccentuation(image);
   
   public Fentre() {
      this.setTitle("Traitement d'images...");
      this.setBounds(50, 50, 600, 400);
      this.setDefaultCloseOperation(this.EXIT_ON_CLOSE);
      this.setExtendedState(this.MAXIMIZED_BOTH);
      this.getContentPane().add(barreBoutons, BorderLayout.NORTH);
      boutonNouvellePhoto.setFocusPainted(false);
      barreBoutons.add(boutonNouvellePhoto);
      barreBoutons.add(boutonNgatif);
      barreBoutons.add(boutonNoirBlanc);
      barreBoutons.add(boutonRotationGauche);
      barreBoutons.add(boutonRotationDroite);
      barreBoutons.add(boutonReinitialiser);
      barreBoutons.add(boutonRetailler);
      barreBoutons.add(boutonSauvegarder);
      this.getContentPane().add(image, BorderLayout.CENTER);
      this.getContentPane().add(palettes, BorderLayout.EAST);
      palettes.setPreferredSize(new Dimension(310, this.getHeight()));
      palettes.add(histogramme);
      palettes.add(niveaux);
      palettes.add(attnuation);
      palettes.add(accentuation);
   }
   public static void main(String[] args) {
      new Fentre().setVisible(true);
   }
}
         