import java.awt.*;
import java.awt.event.*;
import java.lang.reflect.Method;
import javax.swing.*;
import javax.swing.event.*;

class Rglage extends JPanel {
   private Glissire glissire;
   private JLabel valeur = new JLabel("0");
   private JCheckBox actif = new JCheckBox();
   
   public Rglage(String titre, ZoneImage image, String mthode, int minimum, int maximum) throws NoSuchMethodException {
      glissire = new Glissire(valeur, actif, image, mthode, minimum, maximum);
      this.setBorder(BorderFactory.createTitledBorder(titre));
      valeur.setBorder(BorderFactory.createEtchedBorder());
      valeur.setPreferredSize(new Dimension(30, 20));
      valeur.setHorizontalAlignment(valeur.CENTER);
      actif.setSelected(true);
      this.add(actif);
      this.add(valeur);
      this.add(glissire);
   }
}

class Glissire extends JSlider implements ChangeListener, ActionListener {
   private JLabel valeur;
   private JCheckBox actif;
   private ZoneImage image;
   private Method mthode;
   
   public Glissire(JLabel valeur, JCheckBox actif, ZoneImage image, String mthode, int minimum, int maximum) 
         throws NoSuchMethodException {
      super(JSlider.HORIZONTAL, minimum, maximum, 0);
      this.valeur = valeur;
      this.actif = actif;
      this.image = image;
      this.mthode = image.getClass().getMethod(mthode, int.class);
      addChangeListener(this);
      actif.addActionListener(this);
      this.addMouseListener(new RelachementSouris(image));
   }
   public void stateChanged(ChangeEvent e) {
      try {
         mthode.invoke(image, this.getValue());
         valeur.setText(""+this.getValue());
      } 
      catch (Exception ex) {
         ex.printStackTrace();
      }    
   }
   public void actionPerformed(ActionEvent e) {
      this.setEnabled(actif.isSelected());
      valeur.setText(""+(actif.isSelected() ? getValue() : 0));
      try {
         mthode.invoke(image, actif.isSelected() ? getValue() : 0);
      } 
      catch (Exception ex) {
         ex.printStackTrace();
      } 
      image.rglerHistogramme();
   }
}

class RelachementSouris extends MouseAdapter {
   private ZoneImage zone;
   
   public RelachementSouris(ZoneImage zone) {
      this.zone = zone;
   }
   public void mouseReleased(MouseEvent e) {
      zone.rglerHistogramme();
   }
}